commit:     cb9cc405d80a17e2b5329672c871e24d82cfb61e
Author:     Sam James <sam <AT> gentoo <DOT> org>
AuthorDate: Mon Apr 10 04:51:12 2023 +0000
Commit:     Sam James <sam <AT> gentoo <DOT> org>
CommitDate: Mon Apr 10 04:52:35 2023 +0000
URL:        https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=cb9cc405

dev-lang/ruby: don't use baseruby; add HPPA-only fix

1. Disable use of baseruby. This causes breakage if a previous Ruby is installed
without rubygems like in bug #883097. We've had issues like this in the past
in bug #787137 too.

2. Add a fix which is ifdef'd for HPPA (upstream variant isn't, but let's
be more conservative until it's merged there) to fix stack size allocation. This
fixes tests for both Ruby and a bunch of Ruby packages.

Bug: https://bugs.gentoo.org/787137
Closes: https://bugs.gentoo.org/701494
Closes: https://bugs.gentoo.org/883097
Signed-off-by: Sam James <sam <AT> gentoo.org>

 .../files/2.7/902-hppa-pthread-stack-size.patch    |  54 ++++
 .../files/3.0/902-hppa-pthread-stack-size.patch    |  54 ++++
 .../files/3.1/902-hppa-pthread-stack-size.patch    |  54 ++++
 .../files/3.2/902-hppa-pthread-stack-size.patch    |  54 ++++
 dev-lang/ruby/ruby-2.7.8-r1.ebuild                 | 274 +++++++++++++++++++++
 dev-lang/ruby/ruby-3.0.6-r1.ebuild                 | 269 ++++++++++++++++++++
 dev-lang/ruby/ruby-3.1.4-r1.ebuild                 | 253 +++++++++++++++++++
 dev-lang/ruby/ruby-3.2.2-r1.ebuild                 | 272 ++++++++++++++++++++
 8 files changed, 1284 insertions(+)

diff --git a/dev-lang/ruby/files/2.7/902-hppa-pthread-stack-size.patch 
b/dev-lang/ruby/files/2.7/902-hppa-pthread-stack-size.patch
new file mode 100644
index 000000000000..ae834d6e657f
--- /dev/null
+++ b/dev-lang/ruby/files/2.7/902-hppa-pthread-stack-size.patch
@@ -0,0 +1,54 @@
+https://bugs.gentoo.org/701494
+
+From cfac4ee59d09d72820bf220713615cf11211dad2 Mon Sep 17 00:00:00 2001
+From: Sam James <s...@gentoo.org>
+Date: Fri, 7 Apr 2023 11:46:12 +0100
+Subject: [PATCH] thread_pthread: Grow main_stack if required (fixes tests on
+ HPPA)
+
+On HPPA, test_insns.rb fails (along with various Ruby gems) with
+'stack level too deep (SystemStackError)'. This turns out to be because HPPA
+defaults to a small(er) stack.
+
+With this change, most of Ruby's test suite now passes on HPPA.
+
+Thanks to both Dave and Helge for the investigation and coming up with the
+patch.
+
+Bug: https://bugs.gentoo.org/701494
+Bug: https://bugs.debian.org/881773
+Bug: https://bugs.debian.org/881772 (for PPC64)
+Bug: https://github.com/rack/rack/issues/1640
+Thanks-to: John David Anglin <dave.ang...@bell.net>
+Thanks-to: Helge Deller <del...@gmx.de>
+Signed-off-by: Sam James <s...@gentoo.org>
+--- a/thread_pthread.c
++++ b/thread_pthread.c
+@@ -656,8 +656,22 @@ size_t pthread_get_stacksize_np(pthread_t);
+ #   define MAINSTACKADDR_AVAILABLE 0
+ # endif
+ #endif
+-#if MAINSTACKADDR_AVAILABLE && !defined(get_main_stack)
+-# define get_main_stack(addr, size) get_stack(addr, size)
++#if MAINSTACKADDR_AVAILABLE
++static int get_stack(void **, size_t *);
++static int
++get_main_stack(void **addr, size_t *size)
++{
++    int ret = get_stack(addr, size);
++
++#ifdef __hppa__
++    /* On some architectures, the initial stack size may be too small, but 
fortunately,
++       it's growable. Bump it up to the minimum needed if it is too small. */
++    if (*size < RUBY_VM_THREAD_VM_STACK_SIZE)
++        *size = RUBY_VM_THREAD_VM_STACK_SIZE;
++#endif
++
++    return ret;
++}
+ #endif
+ 
+ #ifdef STACKADDR_AVAILABLE
+-- 
+2.40.0
+

diff --git a/dev-lang/ruby/files/3.0/902-hppa-pthread-stack-size.patch 
b/dev-lang/ruby/files/3.0/902-hppa-pthread-stack-size.patch
new file mode 100644
index 000000000000..7978566afc7e
--- /dev/null
+++ b/dev-lang/ruby/files/3.0/902-hppa-pthread-stack-size.patch
@@ -0,0 +1,54 @@
+https://bugs.gentoo.org/701494
+
+From 794b6fce94343c4f9dceca5d08224b0fb364fde8 Mon Sep 17 00:00:00 2001
+From: Sam James <s...@gentoo.org>
+Date: Fri, 7 Apr 2023 11:46:12 +0100
+Subject: [PATCH] thread_pthread: Grow main_stack if required (fixes tests on
+ HPPA)
+
+On HPPA, test_insns.rb fails (along with various Ruby gems) with
+'stack level too deep (SystemStackError)'. This turns out to be because HPPA
+defaults to a small(er) stack.
+
+With this change, most of Ruby's test suite now passes on HPPA.
+
+Thanks to both Dave and Helge for the investigation and coming up with the
+patch.
+
+Bug: https://bugs.gentoo.org/701494
+Bug: https://bugs.debian.org/881773
+Bug: https://bugs.debian.org/881772 (for PPC64)
+Bug: https://github.com/rack/rack/issues/1640
+Thanks-to: John David Anglin <dave.ang...@bell.net>
+Thanks-to: Helge Deller <del...@gmx.de>
+Signed-off-by: Sam James <s...@gentoo.org>
+--- a/thread_pthread.c
++++ b/thread_pthread.c
+@@ -681,8 +681,22 @@ size_t pthread_get_stacksize_np(pthread_t);
+ #   define MAINSTACKADDR_AVAILABLE 0
+ # endif
+ #endif
+-#if MAINSTACKADDR_AVAILABLE && !defined(get_main_stack)
+-# define get_main_stack(addr, size) get_stack(addr, size)
++#if MAINSTACKADDR_AVAILABLE
++static int get_stack(void **, size_t *);
++static int
++get_main_stack(void **addr, size_t *size)
++{
++    int ret = get_stack(addr, size);
++
++#ifdef __hppa__
++    /* On some architectures, the initial stack size may be too small, but 
fortunately,
++       it's growable. Bump it up to the minimum needed if it is too small. */
++    if (*size < RUBY_VM_THREAD_VM_STACK_SIZE)
++        *size = RUBY_VM_THREAD_VM_STACK_SIZE;
++#endif
++
++    return ret;
++}
+ #endif
+ 
+ #ifdef STACKADDR_AVAILABLE
+-- 
+2.40.0
+

diff --git a/dev-lang/ruby/files/3.1/902-hppa-pthread-stack-size.patch 
b/dev-lang/ruby/files/3.1/902-hppa-pthread-stack-size.patch
new file mode 100644
index 000000000000..2578ff03c3a6
--- /dev/null
+++ b/dev-lang/ruby/files/3.1/902-hppa-pthread-stack-size.patch
@@ -0,0 +1,54 @@
+https://bugs.gentoo.org/701494
+
+From 91bfb8a5166f4530ce556a11a4b7fb64983b7686 Mon Sep 17 00:00:00 2001
+From: Sam James <s...@gentoo.org>
+Date: Fri, 7 Apr 2023 11:46:12 +0100
+Subject: [PATCH] thread_pthread: Grow main_stack if required (fixes tests on
+ HPPA)
+
+On HPPA, test_insns.rb fails (along with various Ruby gems) with
+'stack level too deep (SystemStackError)'. This turns out to be because HPPA
+defaults to a small(er) stack.
+
+With this change, most of Ruby's test suite now passes on HPPA.
+
+Thanks to both Dave and Helge for the investigation and coming up with the
+patch.
+
+Bug: https://bugs.gentoo.org/701494
+Bug: https://bugs.debian.org/881773
+Bug: https://bugs.debian.org/881772 (for PPC64)
+Bug: https://github.com/rack/rack/issues/1640
+Thanks-to: John David Anglin <dave.ang...@bell.net>
+Thanks-to: Helge Deller <del...@gmx.de>
+Signed-off-by: Sam James <s...@gentoo.org>
+--- a/thread_pthread.c
++++ b/thread_pthread.c
+@@ -738,8 +738,22 @@ size_t pthread_get_stacksize_np(pthread_t);
+ #   define MAINSTACKADDR_AVAILABLE 0
+ # endif
+ #endif
+-#if MAINSTACKADDR_AVAILABLE && !defined(get_main_stack)
+-# define get_main_stack(addr, size) get_stack(addr, size)
++#if MAINSTACKADDR_AVAILABLE
++static int get_stack(void **, size_t *);
++static int
++get_main_stack(void **addr, size_t *size)
++{
++    int ret = get_stack(addr, size);
++
++#ifdef __hppa__
++    /* On some architectures, the initial stack size may be too small, but 
fortunately,
++       it's growable. Bump it up to the minimum needed if it is too small. */
++    if (*size < RUBY_VM_THREAD_VM_STACK_SIZE)
++        *size = RUBY_VM_THREAD_VM_STACK_SIZE;
++#endif
++
++    return ret;
++}
+ #endif
+ 
+ #ifdef STACKADDR_AVAILABLE
+-- 
+2.40.0
+

diff --git a/dev-lang/ruby/files/3.2/902-hppa-pthread-stack-size.patch 
b/dev-lang/ruby/files/3.2/902-hppa-pthread-stack-size.patch
new file mode 100644
index 000000000000..96e24a340ad9
--- /dev/null
+++ b/dev-lang/ruby/files/3.2/902-hppa-pthread-stack-size.patch
@@ -0,0 +1,54 @@
+https://bugs.gentoo.org/701494
+
+From 40ccf3b91071d3603335b0b7095613ef1843f9e1 Mon Sep 17 00:00:00 2001
+From: Sam James <s...@gentoo.org>
+Date: Fri, 7 Apr 2023 11:46:12 +0100
+Subject: [PATCH] thread_pthread: Grow main_stack if required (fixes tests on
+ HPPA)
+
+On HPPA, test_insns.rb fails (along with various Ruby gems) with
+'stack level too deep (SystemStackError)'. This turns out to be because HPPA
+defaults to a small(er) stack.
+
+With this change, most of Ruby's test suite now passes on HPPA.
+
+Thanks to both Dave and Helge for the investigation and coming up with the
+patch.
+
+Bug: https://bugs.gentoo.org/701494
+Bug: https://bugs.debian.org/881773
+Bug: https://bugs.debian.org/881772 (for PPC64)
+Bug: https://github.com/rack/rack/issues/1640
+Thanks-to: John David Anglin <dave.ang...@bell.net>
+Thanks-to: Helge Deller <del...@gmx.de>
+Signed-off-by: Sam James <s...@gentoo.org>
+--- a/thread_pthread.c
++++ b/thread_pthread.c
+@@ -858,8 +858,22 @@ size_t pthread_get_stacksize_np(pthread_t);
+ #   define MAINSTACKADDR_AVAILABLE 0
+ # endif
+ #endif
+-#if MAINSTACKADDR_AVAILABLE && !defined(get_main_stack)
+-# define get_main_stack(addr, size) get_stack(addr, size)
++#if MAINSTACKADDR_AVAILABLE
++static int get_stack(void **, size_t *);
++static int
++get_main_stack(void **addr, size_t *size)
++{
++    int ret = get_stack(addr, size);
++
++#ifdef __hppa__
++    /* On some architectures, the initial stack size may be too small, but 
fortunately,
++       it's growable. Bump it up to the minimum needed if it is too small. */
++    if (*size < RUBY_VM_THREAD_VM_STACK_SIZE)
++        *size = RUBY_VM_THREAD_VM_STACK_SIZE;
++#endif
++
++    return ret;
++}
+ #endif
+ 
+ #ifdef STACKADDR_AVAILABLE
+-- 
+2.40.0
+

diff --git a/dev-lang/ruby/ruby-2.7.8-r1.ebuild 
b/dev-lang/ruby/ruby-2.7.8-r1.ebuild
new file mode 100644
index 000000000000..6090b5d0a1ab
--- /dev/null
+++ b/dev-lang/ruby/ruby-2.7.8-r1.ebuild
@@ -0,0 +1,274 @@
+# Copyright 1999-2023 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=7
+
+inherit autotools flag-o-matic
+
+MY_P="${PN}-$(ver_cut 1-3)"
+S=${WORKDIR}/${MY_P}
+
+SLOT=$(ver_cut 1-2)
+MY_SUFFIX=$(ver_rs 1 '' ${SLOT})
+RUBYVERSION=${SLOT}.0
+
+DESCRIPTION="An object-oriented scripting language"
+HOMEPAGE="https://www.ruby-lang.org/";
+SRC_URI="https://cache.ruby-lang.org/pub/ruby/${SLOT}/${MY_P}.tar.xz";
+
+LICENSE="|| ( Ruby-BSD BSD-2 )"
+KEYWORDS="~alpha ~amd64 ~arm ~arm64 ~hppa ~loong ~mips ~ppc ~ppc64 ~riscv 
~s390 ~sparc ~x86 ~amd64-linux ~x86-linux ~ppc-macos ~x64-macos ~sparc-solaris 
~sparc64-solaris ~x64-solaris ~x86-solaris"
+IUSE="berkdb debug doc examples gdbm ipv6 jemalloc jit +rdoc rubytests socks5 
+ssl static-libs systemtap tk xemacs"
+
+RDEPEND="
+       berkdb? ( sys-libs/db:= )
+       gdbm? ( sys-libs/gdbm:= )
+       jemalloc? ( dev-libs/jemalloc:= )
+       jit? ( || ( sys-devel/gcc:* sys-devel/clang:* ) )
+       ssl? (
+               =dev-libs/openssl-1.1*:0=
+       )
+       socks5? ( >=net-proxy/dante-1.1.13 )
+       systemtap? ( dev-util/systemtap )
+       tk? (
+               dev-lang/tcl:0=[threads]
+               dev-lang/tk:0=[threads]
+       )
+       dev-libs/libyaml
+       dev-libs/libffi:=
+       sys-libs/readline:0=
+       sys-libs/zlib
+       virtual/libcrypt:=
+       >=app-eselect/eselect-ruby-20191222
+"
+
+DEPEND="${RDEPEND}"
+
+BUNDLED_GEMS="
+       >=dev-ruby/minitest-5.13.0[ruby_targets_ruby27]
+       >=dev-ruby/net-telnet-0.2.0[ruby_targets_ruby27]
+       >=dev-ruby/power_assert-1.1.7[ruby_targets_ruby27]
+       >=dev-ruby/rake-13.0.1[ruby_targets_ruby27]
+       >=dev-ruby/test-unit-3.3.4[ruby_targets_ruby27]
+       >=dev-ruby/xmlrpc-0.3.0[ruby_targets_ruby27]
+"
+
+PDEPEND="
+       ${BUNDLED_GEMS}
+       virtual/rubygems[ruby_targets_ruby27]
+       >=dev-ruby/bundler-2.1.4[ruby_targets_ruby27]
+       >=dev-ruby/did_you_mean-1.3.1[ruby_targets_ruby27]
+       >=dev-ruby/json-2.0.2[ruby_targets_ruby27]
+       rdoc? ( >=dev-ruby/rdoc-6.1.2[ruby_targets_ruby27] )
+       xemacs? ( app-xemacs/ruby-modes )"
+
+src_prepare() {
+       eapply "${FILESDIR}"/2.7/{003,010}*.patch
+       eapply "${FILESDIR}"/2.7/902*.patch
+
+       if use elibc_musl ; then
+               eapply "${FILESDIR}"/2.7/{900,901}-musl-*.patch
+       fi
+
+       # Reset time on patched gem_prelude.rb to avoid the need for a base
+       # ruby during bootstrapping, bug 787137
+       touch -t 202001010000 gem_prelude.rb || die
+
+       einfo "Unbundling gems..."
+       cd "$S"
+       # Remove bundled gems that we will install via PDEPEND, bug
+       # 539700.
+       rm -fr gems/* || die
+       # Don't install CLI tools since they will clash with the gem
+       rm -f bin/{racc,racc2y,y2racc} || die
+       sed -i -e '/executables/ s:^:#:' lib/racc/racc.gemspec || die
+
+       einfo "Removing bundled libraries..."
+       rm -fr ext/fiddle/libffi-3.2.1 || die
+
+       if use prefix ; then
+               # Fix hardcoded SHELL var in mkmf library
+               sed -i -e "s#\(SHELL = \).*#\1${EPREFIX}/bin/sh#" lib/mkmf.rb 
|| die
+
+               if [[ ${CHOST} == *darwin* ]] ; then
+                       # avoid symlink loop on Darwin (?!)
+                       sed -i \
+                               -e 
'/LIBRUBY_ALIASES=/s/lib$(RUBY_INSTALL_NAME).$(SOEXT)//' \
+                               configure.ac || die
+
+                       # make ar/libtool hack for Darwin work
+                       sed -i \
+                               -e 
"s/ac_cv_prog_ac_ct_AR='libtool/ac_cv_prog_AR='${CHOST}-libtool/" \
+                               configure.ac || die
+
+                       # disable using security framework (GCC barfs on those 
headers)
+                       sed -i \
+                               -e 
's/MAC_OS_X_VERSION_MIN_REQUIRED/_DISABLED_/' \
+                               random.c || die
+               fi
+       fi
+
+       eapply_user
+
+       eautoreconf
+}
+
+src_configure() {
+       local modules= myconf=
+
+       # -fomit-frame-pointer makes ruby segfault, see bug #150413.
+       filter-flags -fomit-frame-pointer
+       # In many places aliasing rules are broken; play it safe
+       # as it's risky with newer compilers to leave it as it is.
+       append-flags -fno-strict-aliasing
+
+       # Socks support via dante
+       if use socks5 ; then
+               # Socks support can't be disabled as long as SOCKS_SERVER is
+               # set and socks library is present, so need to unset
+               # SOCKS_SERVER in that case.
+               unset SOCKS_SERVER
+       fi
+
+       # Increase GC_MALLOC_LIMIT if set (default is 8000000)
+       if [ -n "${RUBY_GC_MALLOC_LIMIT}" ] ; then
+               append-flags "-DGC_MALLOC_LIMIT=${RUBY_GC_MALLOC_LIMIT}"
+       fi
+
+       # ipv6 hack, bug 168939. Needs --enable-ipv6.
+       use ipv6 || myconf="${myconf} --with-lookup-order-hack=INET"
+
+       # Determine which modules *not* to build depending in the USE flags.
+       if ! use berkdb ; then
+               modules="${modules},dbm"
+       fi
+       if ! use gdbm ; then
+               modules="${modules},gdbm"
+       fi
+       if ! use ssl ; then
+               modules="${modules},openssl"
+       fi
+       if ! use tk ; then
+               modules="${modules},tk"
+       fi
+
+       # Provide an empty LIBPATHENV because we disable rpath but we do not
+       # need LD_LIBRARY_PATH by default since that breaks USE=multitarget
+       # #564272
+       INSTALL="${EPREFIX}/usr/bin/install -c" LIBPATHENV="" econf \
+               --program-suffix=${MY_SUFFIX} \
+               --with-soname=ruby${MY_SUFFIX} \
+               --with-readline-dir="${EPREFIX}"/usr \
+               --enable-shared \
+               --enable-pthread \
+               --disable-rpath \
+               --without-baseruby \
+               --with-out-ext="${modules}" \
+               $(use_with jemalloc jemalloc) \
+               $(use_enable jit jit-support ) \
+               $(use_enable socks5 socks) \
+               $(use_enable systemtap dtrace) \
+               $(use_enable doc install-doc) \
+               --enable-ipv6 \
+               $(use_enable static-libs static) \
+               $(use_enable static-libs install-static-library) \
+               $(use_with static-libs static-linked-ext) \
+               $(use_enable debug) \
+               ${myconf} \
+               --enable-option-checking=no
+
+       # Makefile is broken because it lacks -ldl
+       rm -rf ext/-test-/popen_deadlock || die
+}
+
+src_compile() {
+       emake V=1 EXTLDFLAGS="${LDFLAGS}" MJIT_CFLAGS="${CFLAGS}" 
MJIT_OPTFLAGS="" MJIT_DEBUGFLAGS=""
+}
+
+src_test() {
+       emake -j1 V=1 test
+
+       elog "Ruby's make test has been run. Ruby also ships with a make check"
+       elog "that cannot be run until after ruby has been installed."
+       elog
+       if use rubytests; then
+               elog "You have enabled rubytests, so they will be installed to"
+               elog "/usr/share/${PN}-${SLOT}/test. To run them you must be a 
user other"
+               elog "than root, and you must place them into a writeable 
directory."
+               elog "Then call: "
+               elog
+               elog "ruby${MY_SUFFIX} -C /location/of/tests runner.rb"
+       else
+               elog "Enable the rubytests USE flag to install the make check 
tests"
+       fi
+}
+
+src_install() {
+       # Remove the remaining bundled gems. We do this late in the process
+       # since they are used during the build to e.g. create the
+       # documentation.
+       einfo "Removing default gems before installation"
+       rm -rf lib/bundler* lib/rdoc/rdoc.gemspec || die
+
+       # Ruby is involved in the install process, we don't want interference 
here.
+       unset RUBYOPT
+
+       local MINIRUBY=$(echo -e 'include Makefile\ngetminiruby:\n\t@echo 
$(MINIRUBY)'|make -f - getminiruby)
+
+       
LD_LIBRARY_PATH="${S}:${ED}/usr/$(get_libdir)${LD_LIBRARY_PATH+:}${LD_LIBRARY_PATH}"
+
+       if [[ ${CHOST} == *darwin* ]] ; then
+               
DYLD_LIBRARY_PATH="${S}:${ED}/usr/$(get_libdir)${DYLD_LIBRARY_PATH+:}${DYLD_LIBRARY_PATH}"
+               export DYLD_LIBRARY_PATH
+       fi
+
+       RUBYLIB="${S}:${ED}/usr/$(get_libdir)/ruby/${RUBYVERSION}"
+       for d in $(find "${S}/ext" -type d) ; do
+               RUBYLIB="${RUBYLIB}:$d"
+       done
+       export LD_LIBRARY_PATH RUBYLIB
+
+       # Create directory for the default gems
+       local gem_home="${EPREFIX}/usr/$(get_libdir)/ruby/gems/${RUBYVERSION}"
+       mkdir -p "${D}/${gem_home}" || die "mkdir gem home failed"
+
+       emake V=1 DESTDIR="${D}" GEM_DESTDIR=${gem_home} install
+
+       # Remove installed rubygems and rdoc copy
+       rm -rf "${ED}/usr/$(get_libdir)/ruby/${RUBYVERSION}/rubygems" || die 
"rm rubygems failed"
+       rm -rf "${ED}/usr/bin/"gem"${MY_SUFFIX}" || die "rm rdoc bins failed"
+       rm -rf "${ED}/usr/$(get_libdir)/ruby/${RUBYVERSION}"/rdoc* || die "rm 
rdoc failed"
+       rm -rf "${ED}/usr/bin/"{bundle,bundler,ri,rdoc}"${MY_SUFFIX}" || die 
"rm rdoc bins failed"
+
+       if use doc; then
+               emake DESTDIR="${D}" GEM_DESTDIR=${gem_home} install-doc
+       fi
+
+       if use examples; then
+               dodoc -r sample
+       fi
+
+       dodoc ChangeLog NEWS doc/NEWS* README*
+
+       if use rubytests; then
+               pushd test
+               insinto /usr/share/${PN}-${SLOT}/test
+               doins -r .
+               popd
+       fi
+}
+
+pkg_postinst() {
+       if [[ ! -n $(readlink "${EROOT}"/usr/bin/ruby) ]] ; then
+               eselect ruby set ruby${MY_SUFFIX}
+       fi
+
+       elog
+       elog "To switch between available Ruby profiles, execute as root:"
+       elog "\teselect ruby set ruby(23|24|...)"
+       elog
+}
+
+pkg_postrm() {
+       eselect ruby cleanup
+}

diff --git a/dev-lang/ruby/ruby-3.0.6-r1.ebuild 
b/dev-lang/ruby/ruby-3.0.6-r1.ebuild
new file mode 100644
index 000000000000..fd4e239eb841
--- /dev/null
+++ b/dev-lang/ruby/ruby-3.0.6-r1.ebuild
@@ -0,0 +1,269 @@
+# Copyright 1999-2023 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=7
+
+inherit autotools flag-o-matic
+
+MY_P="${PN}-$(ver_cut 1-3)"
+S=${WORKDIR}/${MY_P}
+
+SLOT=$(ver_cut 1-2)
+MY_SUFFIX=$(ver_rs 1 '' ${SLOT})
+RUBYVERSION=${SLOT}.0
+
+DESCRIPTION="An object-oriented scripting language"
+HOMEPAGE="https://www.ruby-lang.org/";
+SRC_URI="https://cache.ruby-lang.org/pub/ruby/${SLOT}/${MY_P}.tar.xz";
+
+LICENSE="|| ( Ruby-BSD BSD-2 )"
+KEYWORDS="~alpha ~amd64 ~arm ~arm64 ~hppa ~loong ~mips ~ppc ~ppc64 ~riscv 
~s390 ~sparc ~x86 ~amd64-linux ~x86-linux ~ppc-macos ~x64-macos ~sparc-solaris 
~sparc64-solaris ~x64-solaris ~x86-solaris"
+IUSE="berkdb debug doc examples gdbm ipv6 jemalloc jit +rdoc rubytests socks5 
+ssl static-libs systemtap tk xemacs"
+
+RDEPEND="
+       berkdb? ( sys-libs/db:= )
+       gdbm? ( sys-libs/gdbm:= )
+       jemalloc? ( dev-libs/jemalloc:= )
+       jit? ( || ( sys-devel/gcc:* sys-devel/clang:* ) )
+       ssl? (
+               =dev-libs/openssl-1.1*:0=
+       )
+       socks5? ( >=net-proxy/dante-1.1.13 )
+       systemtap? ( dev-util/systemtap )
+       tk? (
+               dev-lang/tcl:0=[threads]
+               dev-lang/tk:0=[threads]
+       )
+       dev-libs/libyaml
+       dev-libs/libffi:=
+       sys-libs/readline:0=
+       sys-libs/zlib
+       virtual/libcrypt:=
+       >=app-eselect/eselect-ruby-20201225
+"
+
+DEPEND="${RDEPEND}"
+
+BUNDLED_GEMS="
+       >=dev-ruby/minitest-5.14.2[ruby_targets_ruby30]
+       >=dev-ruby/power_assert-1.2.0[ruby_targets_ruby30]
+       >=dev-ruby/rake-13.0.3[ruby_targets_ruby30]
+       >=dev-ruby/rbs-1.0.0[ruby_targets_ruby30]
+       >=dev-ruby/rexml-3.2.4[ruby_targets_ruby30]
+       >=dev-ruby/rss-0.2.9[ruby_targets_ruby30]
+       >=dev-ruby/test-unit-3.3.7[ruby_targets_ruby30]
+       >=dev-ruby/typeprof-0.11.0[ruby_targets_ruby30]
+"
+
+PDEPEND="
+       ${BUNDLED_GEMS}
+       virtual/rubygems[ruby_targets_ruby30]
+       >=dev-ruby/bundler-2.2.15[ruby_targets_ruby30]
+       >=dev-ruby/did_you_mean-1.5.0[ruby_targets_ruby30]
+       >=dev-ruby/json-2.5.1[ruby_targets_ruby30]
+       rdoc? ( >=dev-ruby/rdoc-6.3.0[ruby_targets_ruby30] )
+       xemacs? ( app-xemacs/ruby-modes )"
+
+src_prepare() {
+       eapply "${FILESDIR}"/"${SLOT}"/010*.patch
+       eapply "${FILESDIR}"/"${SLOT}"/902*.patch
+
+       if use elibc_musl ; then
+               eapply "${FILESDIR}"/3.0/900-musl-*.patch
+               eapply "${FILESDIR}"/3.0/901-musl-*.patch
+       fi
+
+       einfo "Unbundling gems..."
+       cd "$S"
+       # Remove bundled gems that we will install via PDEPEND, bug
+       # 539700.
+       rm -fr gems/* || die
+       touch gems/bundled_gems || die
+       # Don't install CLI tools since they will clash with the gem
+       rm -f bin/{racc,racc2y,y2racc} || die
+       sed -i -e '/executables/ s:^:#:' lib/racc/racc.gemspec || die
+
+       einfo "Removing bundled libraries..."
+       rm -fr ext/fiddle/libffi-3.2.1 || die
+
+       if use prefix ; then
+               # Fix hardcoded SHELL var in mkmf library
+               sed -i -e "s#\(SHELL = \).*#\1${EPREFIX}/bin/sh#" lib/mkmf.rb 
|| die
+
+               if [[ ${CHOST} == *darwin* ]] ; then
+                       # avoid symlink loop on Darwin (?!)
+                       sed -i \
+                               -e 
'/LIBRUBY_ALIASES=/s/lib$(RUBY_INSTALL_NAME).$(SOEXT)//' \
+                               configure.ac || die
+
+                       # make ar/libtool hack for Darwin work
+                       sed -i \
+                               -e 
"s/ac_cv_prog_ac_ct_AR='libtool/ac_cv_prog_AR='${CHOST}-libtool/" \
+                               configure.ac || die
+               fi
+       fi
+
+       eapply_user
+
+       eautoreconf
+}
+
+src_configure() {
+       local modules= myconf=
+
+       # -fomit-frame-pointer makes ruby segfault, see bug #150413.
+       filter-flags -fomit-frame-pointer
+       # In many places aliasing rules are broken; play it safe
+       # as it's risky with newer compilers to leave it as it is.
+       append-flags -fno-strict-aliasing
+
+       # Socks support via dante
+       if use socks5 ; then
+               # Socks support can't be disabled as long as SOCKS_SERVER is
+               # set and socks library is present, so need to unset
+               # SOCKS_SERVER in that case.
+               unset SOCKS_SERVER
+       fi
+
+       # Increase GC_MALLOC_LIMIT if set (default is 8000000)
+       if [ -n "${RUBY_GC_MALLOC_LIMIT}" ] ; then
+               append-flags "-DGC_MALLOC_LIMIT=${RUBY_GC_MALLOC_LIMIT}"
+       fi
+
+       # ipv6 hack, bug 168939. Needs --enable-ipv6.
+       use ipv6 || myconf="${myconf} --with-lookup-order-hack=INET"
+
+       # Determine which modules *not* to build depending in the USE flags.
+       if ! use berkdb ; then
+               modules="${modules},dbm"
+       fi
+       if ! use gdbm ; then
+               modules="${modules},gdbm"
+       fi
+       if ! use ssl ; then
+               modules="${modules},openssl"
+       fi
+       if ! use tk ; then
+               modules="${modules},tk"
+       fi
+
+       # Provide an empty LIBPATHENV because we disable rpath but we do not
+       # need LD_LIBRARY_PATH by default since that breaks USE=multitarget
+       # #564272
+       INSTALL="${EPREFIX}/usr/bin/install -c" LIBPATHENV="" econf \
+               --program-suffix=${MY_SUFFIX} \
+               --with-soname=ruby${MY_SUFFIX} \
+               --with-readline-dir="${EPREFIX}"/usr \
+               --enable-shared \
+               --enable-pthread \
+               --disable-rpath \
+               --without-baseruby \
+               --with-out-ext="${modules}" \
+               $(use_with jemalloc jemalloc) \
+               $(use_enable jit jit-support ) \
+               $(use_enable socks5 socks) \
+               $(use_enable systemtap dtrace) \
+               $(use_enable doc install-doc) \
+               --enable-ipv6 \
+               $(use_enable static-libs static) \
+               $(use_enable static-libs install-static-library) \
+               $(use_with static-libs static-linked-ext) \
+               $(use_enable debug) \
+               ${myconf} \
+               --enable-option-checking=no
+
+       # Makefile is broken because it lacks -ldl
+       rm -rf ext/-test-/popen_deadlock || die
+}
+
+src_compile() {
+       emake V=1 EXTLDFLAGS="${LDFLAGS}" MJIT_CFLAGS="${CFLAGS}" 
MJIT_OPTFLAGS="" MJIT_DEBUGFLAGS=""
+}
+
+src_test() {
+       emake -j1 V=1 test
+
+       elog "Ruby's make test has been run. Ruby also ships with a make check"
+       elog "that cannot be run until after ruby has been installed."
+       elog
+       if use rubytests; then
+               elog "You have enabled rubytests, so they will be installed to"
+               elog "/usr/share/${PN}-${SLOT}/test. To run them you must be a 
user other"
+               elog "than root, and you must place them into a writeable 
directory."
+               elog "Then call: "
+               elog
+               elog "ruby${MY_SUFFIX} -C /location/of/tests runner.rb"
+       else
+               elog "Enable the rubytests USE flag to install the make check 
tests"
+       fi
+}
+
+src_install() {
+       # Remove the remaining bundled gems. We do this late in the process
+       # since they are used during the build to e.g. create the
+       # documentation.
+       einfo "Removing default gems before installation"
+       rm -rf lib/bundler* lib/rdoc/rdoc.gemspec || die
+
+       # Ruby is involved in the install process, we don't want interference 
here.
+       unset RUBYOPT
+
+       local MINIRUBY=$(echo -e 'include Makefile\ngetminiruby:\n\t@echo 
$(MINIRUBY)'|make -f - getminiruby)
+
+       
LD_LIBRARY_PATH="${S}:${ED}/usr/$(get_libdir)${LD_LIBRARY_PATH+:}${LD_LIBRARY_PATH}"
+
+       if [[ ${CHOST} == *darwin* ]] ; then
+               
DYLD_LIBRARY_PATH="${S}:${ED}/usr/$(get_libdir)${DYLD_LIBRARY_PATH+:}${DYLD_LIBRARY_PATH}"
+               export DYLD_LIBRARY_PATH
+       fi
+
+       RUBYLIB="${S}:${ED}/usr/$(get_libdir)/ruby/${RUBYVERSION}"
+       for d in $(find "${S}/ext" -type d) ; do
+               RUBYLIB="${RUBYLIB}:$d"
+       done
+       export LD_LIBRARY_PATH RUBYLIB
+
+       # Create directory for the default gems
+       local gem_home="${EPREFIX}/usr/$(get_libdir)/ruby/gems/${RUBYVERSION}"
+       mkdir -p "${D}/${gem_home}" || die "mkdir gem home failed"
+
+       emake V=1 DESTDIR="${D}" GEM_DESTDIR=${gem_home} install
+
+       # Remove installed rubygems and rdoc copy
+       rm -rf "${ED}/usr/$(get_libdir)/ruby/${RUBYVERSION}/rubygems" || die 
"rm rubygems failed"
+       rm -rf "${ED}/usr/bin/"gem"${MY_SUFFIX}" || die "rm rdoc bins failed"
+       rm -rf "${ED}/usr/$(get_libdir)/ruby/${RUBYVERSION}"/rdoc* || die "rm 
rdoc failed"
+       rm -rf "${ED}/usr/bin/"{bundle,bundler,ri,rdoc}"${MY_SUFFIX}" || die 
"rm rdoc bins failed"
+
+       if use doc; then
+               emake DESTDIR="${D}" GEM_DESTDIR=${gem_home} install-doc
+       fi
+
+       if use examples; then
+               dodoc -r sample
+       fi
+
+       dodoc ChangeLog NEWS.md doc/NEWS* README*
+
+       if use rubytests; then
+               pushd test
+               insinto /usr/share/${PN}-${SLOT}/test
+               doins -r .
+               popd
+       fi
+}
+
+pkg_postinst() {
+       if [[ ! -n $(readlink "${EROOT}"/usr/bin/ruby) ]] ; then
+               eselect ruby set ruby${MY_SUFFIX}
+       fi
+
+       elog
+       elog "To switch between available Ruby profiles, execute as root:"
+       elog "\teselect ruby set ruby(23|24|...)"
+       elog
+}
+
+pkg_postrm() {
+       eselect ruby cleanup
+}

diff --git a/dev-lang/ruby/ruby-3.1.4-r1.ebuild 
b/dev-lang/ruby/ruby-3.1.4-r1.ebuild
new file mode 100644
index 000000000000..9f545678341d
--- /dev/null
+++ b/dev-lang/ruby/ruby-3.1.4-r1.ebuild
@@ -0,0 +1,253 @@
+# Copyright 1999-2023 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=8
+
+inherit autotools flag-o-matic
+
+MY_P="${PN}-$(ver_cut 1-3)"
+S=${WORKDIR}/${MY_P}
+
+SLOT=$(ver_cut 1-2)
+MY_SUFFIX=$(ver_rs 1 '' ${SLOT})
+RUBYVERSION=${SLOT}.0
+
+DESCRIPTION="An object-oriented scripting language"
+HOMEPAGE="https://www.ruby-lang.org/";
+SRC_URI="https://cache.ruby-lang.org/pub/ruby/${SLOT}/${MY_P}.tar.xz";
+
+LICENSE="|| ( Ruby-BSD BSD-2 )"
+KEYWORDS="~alpha ~amd64 ~arm ~arm64 ~hppa ~loong ~mips ~ppc ~ppc64 ~riscv 
~s390 ~sparc ~x86 ~amd64-linux ~x86-linux ~ppc-macos ~x64-macos ~sparc-solaris 
~sparc64-solaris ~x64-solaris ~x86-solaris"
+IUSE="berkdb debug doc examples gdbm ipv6 jemalloc jit +rdoc socks5 +ssl 
static-libs systemtap tk xemacs"
+
+RDEPEND="
+       berkdb? ( sys-libs/db:= )
+       gdbm? ( sys-libs/gdbm:= )
+       jemalloc? ( dev-libs/jemalloc:= )
+       jit? ( || ( sys-devel/gcc:* sys-devel/clang:* ) )
+       ssl? (
+               dev-libs/openssl:0=
+       )
+       socks5? ( >=net-proxy/dante-1.1.13 )
+       systemtap? ( dev-util/systemtap )
+       tk? (
+               dev-lang/tcl:0=[threads]
+               dev-lang/tk:0=[threads]
+       )
+       dev-libs/libyaml
+       dev-libs/libffi:=
+       sys-libs/readline:0=
+       sys-libs/zlib
+       virtual/libcrypt:=
+       >=app-eselect/eselect-ruby-20201225
+"
+
+DEPEND="${RDEPEND}"
+
+BUNDLED_GEMS="
+       >=dev-ruby/minitest-5.15.0[ruby_targets_ruby31]
+       >=dev-ruby/power_assert-2.0.1[ruby_targets_ruby31]
+       >=dev-ruby/rake-13.0.6[ruby_targets_ruby31]
+       >=dev-ruby/rbs-2.1.0[ruby_targets_ruby31]
+       >=dev-ruby/rexml-3.2.5[ruby_targets_ruby31]
+       >=dev-ruby/rss-0.2.9[ruby_targets_ruby31]
+       >=dev-ruby/test-unit-3.5.3[ruby_targets_ruby31]
+       >=dev-ruby/typeprof-0.12.2[ruby_targets_ruby31]
+"
+
+PDEPEND="
+       ${BUNDLED_GEMS}
+       virtual/rubygems[ruby_targets_ruby31]
+       >=dev-ruby/bundler-2.3.3[ruby_targets_ruby31]
+       >=dev-ruby/did_you_mean-1.6.1[ruby_targets_ruby31]
+       >=dev-ruby/json-2.6.1[ruby_targets_ruby31]
+       rdoc? ( >=dev-ruby/rdoc-6.3.3[ruby_targets_ruby31] )
+       xemacs? ( app-xemacs/ruby-modes )"
+
+src_prepare() {
+       eapply "${FILESDIR}"/"${SLOT}"/011*.patch
+       eapply "${FILESDIR}"/"${SLOT}"/902*.patch
+
+       if use elibc_musl ; then
+               eapply "${FILESDIR}"/3.1/901-musl-*.patch
+       fi
+
+       einfo "Unbundling gems..."
+       cd "$S"
+       # Remove bundled gems that we will install via PDEPEND, bug
+       # 539700.
+       rm -fr gems/* || die
+       touch gems/bundled_gems || die
+       # Don't install CLI tools since they will clash with the gem
+       rm -f bin/{racc,racc2y,y2racc} || die
+       sed -i -e '/executables/ s:^:#:' lib/racc/racc.gemspec || die
+
+       einfo "Removing bundled libraries..."
+       rm -fr ext/fiddle/libffi-3.2.1 || die
+
+       # Remove tests that are known to fail or require a network connection
+       rm -f test/ruby/test_process.rb 
test/rubygems/test_gem{,_path_support}.rb || die
+       rm -f test/rinda/test_rinda.rb test/socket/test_tcp.rb 
test/fiber/test_address_resolve.rb test/resolv/test_addr.rb \
+          spec/ruby/library/socket/tcpsocket/{initialize,open}_spec.rb|| die
+       sed -i -e '/def test_test/askip "Depends on system setup"' 
test/ruby/test_file_exhaustive.rb || die
+
+       if use prefix ; then
+               # Fix hardcoded SHELL var in mkmf library
+               sed -i -e "s#\(SHELL = \).*#\1${EPREFIX}/bin/sh#" lib/mkmf.rb 
|| die
+
+               if [[ ${CHOST} == *darwin* ]] ; then
+                       # avoid symlink loop on Darwin (?!)
+                       sed -i \
+                               -e 
'/LIBRUBY_ALIASES=/s/lib$(RUBY_INSTALL_NAME).$(SOEXT)//' \
+                               configure.ac || die
+
+                       # make ar/libtool hack for Darwin work
+                       sed -i \
+                               -e 
"s/ac_cv_prog_ac_ct_AR='libtool/ac_cv_prog_AR='${CHOST}-libtool/" \
+                               configure.ac || die
+               fi
+       fi
+
+       eapply_user
+
+       eautoreconf
+}
+
+src_configure() {
+       local modules="win32,win32ole" myconf=
+
+       # -fomit-frame-pointer makes ruby segfault, see bug #150413.
+       filter-flags -fomit-frame-pointer
+       # In many places aliasing rules are broken; play it safe
+       # as it's risky with newer compilers to leave it as it is.
+       append-flags -fno-strict-aliasing
+
+       # Socks support via dante
+       if use socks5 ; then
+               # Socks support can't be disabled as long as SOCKS_SERVER is
+               # set and socks library is present, so need to unset
+               # SOCKS_SERVER in that case.
+               unset SOCKS_SERVER
+       fi
+
+       # Increase GC_MALLOC_LIMIT if set (default is 8000000)
+       if [ -n "${RUBY_GC_MALLOC_LIMIT}" ] ; then
+               append-flags "-DGC_MALLOC_LIMIT=${RUBY_GC_MALLOC_LIMIT}"
+       fi
+
+       # ipv6 hack, bug 168939. Needs --enable-ipv6.
+       use ipv6 || myconf="${myconf} --with-lookup-order-hack=INET"
+
+       # Determine which modules *not* to build depending in the USE flags.
+       if ! use berkdb ; then
+               modules="${modules},dbm"
+       fi
+       if ! use gdbm ; then
+               modules="${modules},gdbm"
+       fi
+       if ! use ssl ; then
+               modules="${modules},openssl"
+       fi
+       if ! use tk ; then
+               modules="${modules},tk"
+       fi
+
+       # Provide an empty LIBPATHENV because we disable rpath but we do not
+       # need LD_LIBRARY_PATH by default since that breaks USE=multitarget
+       # #564272
+       INSTALL="${EPREFIX}/usr/bin/install -c" LIBPATHENV="" econf \
+               --program-suffix=${MY_SUFFIX} \
+               --with-soname=ruby${MY_SUFFIX} \
+               --with-readline-dir="${EPREFIX}"/usr \
+               --enable-shared \
+               --enable-pthread \
+               --disable-rpath \
+               --without-baseruby \
+               --with-out-ext="${modules}" \
+               $(use_with jemalloc jemalloc) \
+               $(use_enable jit jit-support ) \
+               $(use_enable socks5 socks) \
+               $(use_enable systemtap dtrace) \
+               $(use_enable doc install-doc) \
+               --enable-ipv6 \
+               $(use_enable static-libs static) \
+               $(use_enable static-libs install-static-library) \
+               $(use_with static-libs static-linked-ext) \
+               $(use_enable debug) \
+               ${myconf} \
+               --enable-option-checking=no
+
+       # Makefile is broken because it lacks -ldl
+       rm -rf ext/-test-/popen_deadlock || die
+}
+
+src_compile() {
+       emake V=1 EXTLDFLAGS="${LDFLAGS}" MJIT_CFLAGS="${CFLAGS}" 
MJIT_OPTFLAGS="" MJIT_DEBUGFLAGS=""
+}
+
+src_test() {
+       emake V=1 check
+}
+
+src_install() {
+       # Remove the remaining bundled gems. We do this late in the process
+       # since they are used during the build to e.g. create the
+       # documentation.
+       einfo "Removing default gems before installation"
+       rm -rf lib/bundler* lib/rdoc/rdoc.gemspec || die
+
+       # Ruby is involved in the install process, we don't want interference 
here.
+       unset RUBYOPT
+
+       local MINIRUBY=$(echo -e 'include Makefile\ngetminiruby:\n\t@echo 
$(MINIRUBY)'|make -f - getminiruby)
+
+       
LD_LIBRARY_PATH="${S}:${ED}/usr/$(get_libdir)${LD_LIBRARY_PATH+:}${LD_LIBRARY_PATH}"
+
+       if [[ ${CHOST} == *darwin* ]] ; then
+               
DYLD_LIBRARY_PATH="${S}:${ED}/usr/$(get_libdir)${DYLD_LIBRARY_PATH+:}${DYLD_LIBRARY_PATH}"
+               export DYLD_LIBRARY_PATH
+       fi
+
+       RUBYLIB="${S}:${ED}/usr/$(get_libdir)/ruby/${RUBYVERSION}"
+       for d in $(find "${S}/ext" -type d) ; do
+               RUBYLIB="${RUBYLIB}:$d"
+       done
+       export LD_LIBRARY_PATH RUBYLIB
+
+       # Create directory for the default gems
+       local gem_home="${EPREFIX}/usr/$(get_libdir)/ruby/gems/${RUBYVERSION}"
+       mkdir -p "${D}/${gem_home}" || die "mkdir gem home failed"
+
+       emake V=1 DESTDIR="${D}" GEM_DESTDIR=${gem_home} install
+
+       # Remove installed rubygems and rdoc copy
+       rm -rf "${ED}/usr/$(get_libdir)/ruby/${RUBYVERSION}/rubygems" || die 
"rm rubygems failed"
+       rm -rf "${ED}/usr/bin/"gem"${MY_SUFFIX}" || die "rm rdoc bins failed"
+       rm -rf "${ED}/usr/$(get_libdir)/ruby/${RUBYVERSION}"/rdoc* || die "rm 
rdoc failed"
+       rm -rf "${ED}/usr/bin/"{bundle,bundler,ri,rdoc}"${MY_SUFFIX}" || die 
"rm rdoc bins failed"
+
+       if use doc; then
+               emake DESTDIR="${D}" GEM_DESTDIR=${gem_home} install-doc
+       fi
+
+       if use examples; then
+               dodoc -r sample
+       fi
+
+       dodoc ChangeLog NEWS.md doc/NEWS* README*
+}
+
+pkg_postinst() {
+       if [[ ! -n $(readlink "${EROOT}"/usr/bin/ruby) ]] ; then
+               eselect ruby set ruby${MY_SUFFIX}
+       fi
+
+       elog
+       elog "To switch between available Ruby profiles, execute as root:"
+       elog "\teselect ruby set ruby(23|24|...)"
+       elog
+}
+
+pkg_postrm() {
+       eselect ruby cleanup
+}

diff --git a/dev-lang/ruby/ruby-3.2.2-r1.ebuild 
b/dev-lang/ruby/ruby-3.2.2-r1.ebuild
new file mode 100644
index 000000000000..f77a9a393e65
--- /dev/null
+++ b/dev-lang/ruby/ruby-3.2.2-r1.ebuild
@@ -0,0 +1,272 @@
+# Copyright 1999-2023 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=8
+
+inherit autotools flag-o-matic
+
+MY_P="${PN}-$(ver_cut 1-3)"
+S=${WORKDIR}/${MY_P}
+
+SLOT=$(ver_cut 1-2)
+MY_SUFFIX=$(ver_rs 1 '' ${SLOT})
+RUBYVERSION=${SLOT}.0
+
+DESCRIPTION="An object-oriented scripting language"
+HOMEPAGE="https://www.ruby-lang.org/";
+SRC_URI="https://cache.ruby-lang.org/pub/ruby/${SLOT}/${MY_P}.tar.xz";
+
+LICENSE="|| ( Ruby-BSD BSD-2 )"
+KEYWORDS="~alpha ~amd64 ~arm ~arm64 ~hppa ~loong ~mips ~ppc ~ppc64 ~riscv 
~s390 ~sparc ~x86 ~amd64-linux ~x86-linux ~ppc-macos ~x64-macos ~sparc-solaris 
~sparc64-solaris ~x64-solaris ~x86-solaris"
+IUSE="berkdb debug doc examples gdbm ipv6 jemalloc jit +rdoc socks5 +ssl 
static-libs systemtap tk xemacs"
+
+RDEPEND="
+       berkdb? ( sys-libs/db:= )
+       gdbm? ( sys-libs/gdbm:= )
+       jemalloc? ( dev-libs/jemalloc:= )
+       jit? ( >=virtual/rust-1.58.1 )
+       ssl? (
+               dev-libs/openssl:0=
+       )
+       socks5? ( >=net-proxy/dante-1.1.13 )
+       systemtap? ( dev-util/systemtap )
+       tk? (
+               dev-lang/tcl:0=[threads]
+               dev-lang/tk:0=[threads]
+       )
+       dev-libs/libyaml
+       dev-libs/libffi:=
+       sys-libs/readline:0=
+       sys-libs/zlib
+       virtual/libcrypt:=
+       >=app-eselect/eselect-ruby-20221225
+"
+
+DEPEND="${RDEPEND}"
+
+BUNDLED_GEMS="
+       >=dev-ruby/debug-1.7.1[ruby_targets_ruby32]
+       >=dev-ruby/matrix-0.4.2[ruby_targets_ruby32]
+       >=dev-ruby/minitest-5.16.3[ruby_targets_ruby32]
+       >=dev-ruby/net-ftp-0.2.0[ruby_targets_ruby32]
+       >=dev-ruby/net-imap-0.3.4[ruby_targets_ruby32]
+       >=dev-ruby/net-pop-0.1.2[ruby_targets_ruby32]
+       >=dev-ruby/net-smtp-0.3.3[ruby_targets_ruby32]
+       >=dev-ruby/power_assert-2.0.3[ruby_targets_ruby32]
+       >=dev-ruby/prime-0.1.2[ruby_targets_ruby32]
+       >=dev-ruby/rake-13.0.6[ruby_targets_ruby32]
+       >=dev-ruby/rbs-2.8.2[ruby_targets_ruby32]
+       >=dev-ruby/rexml-3.2.5[ruby_targets_ruby32]
+       >=dev-ruby/rss-0.2.9[ruby_targets_ruby32]
+       >=dev-ruby/test-unit-3.5.7[ruby_targets_ruby32]
+       >=dev-ruby/typeprof-0.21.3[ruby_targets_ruby32]
+"
+
+PDEPEND="
+       ${BUNDLED_GEMS}
+       virtual/rubygems[ruby_targets_ruby32]
+       >=dev-ruby/bundler-2.3.3[ruby_targets_ruby32]
+       >=dev-ruby/did_you_mean-1.6.1[ruby_targets_ruby32]
+       >=dev-ruby/json-2.6.1[ruby_targets_ruby32]
+       rdoc? ( >=dev-ruby/rdoc-6.3.3[ruby_targets_ruby32] )
+       xemacs? ( app-xemacs/ruby-modes )"
+
+src_prepare() {
+       eapply "${FILESDIR}"/"${SLOT}"/010*.patch
+       eapply "${FILESDIR}"/"${SLOT}"/902*.patch
+
+       if use elibc_musl ; then
+               eapply "${FILESDIR}"/${SLOT}/901-musl-*.patch
+       fi
+
+       einfo "Unbundling gems..."
+       cd "$S"
+       # Remove bundled gems that we will install via PDEPEND, bug
+       # 539700.
+       rm -fr gems/* || die
+       touch gems/bundled_gems || die
+       # Don't install CLI tools since they will clash with the gem
+       rm -f bin/{racc,racc2y,y2racc} || die
+       sed -i -e '/executables/ s:^:#:' lib/racc/racc.gemspec || die
+
+       # Remove tests that are known to fail or require a network connection
+       rm -f test/ruby/test_process.rb 
test/rubygems/test_gem{,_path_support}.rb || die
+       rm -f test/rinda/test_rinda.rb test/socket/test_tcp.rb 
test/fiber/test_address_resolve.rb 
spec/ruby/library/socket/tcpsocket/{initialize,open}_spec.rb|| die
+
+       # Remove webrick tests because setting LD_LIBRARY_PATH does not work 
for them.
+       rm -rf tool/test/webrick || die
+
+       # Avoid test using the system ruby
+       sed -i -e '/test_dumb_terminal/aomit "Uses system ruby"' 
test/reline/test_reline.rb || die
+
+       # Avoid testing against hard-coded blockdev devices that most likely 
are not available
+       sed -i -e '/def blockdev/a@blockdev = nil' 
test/ruby/test_file_exhaustive.rb || die
+
+       # Avoid tests that require gem downloads
+       sed -i -e '/^test-syntax-suggest/ s/\$(TEST_RUNNABLE)/no/' common.mk || 
die
+       sed -i -e '/^check:/ s/\$(TEST_RUNNABLE)-\$(PREPARE_SYNTAX_SUGGEST) 
test-syntax-suggest//' common.mk || die
+
+       if use prefix ; then
+               # Fix hardcoded SHELL var in mkmf library
+               sed -i -e "s#\(SHELL = \).*#\1${EPREFIX}/bin/sh#" lib/mkmf.rb 
|| die
+
+               if [[ ${CHOST} == *darwin* ]] ; then
+                       # avoid symlink loop on Darwin (?!)
+                       sed -i \
+                               -e 
'/LIBRUBY_ALIASES=/s/lib$(RUBY_INSTALL_NAME).$(SOEXT)//' \
+                               configure.ac || die
+
+                       # make ar/libtool hack for Darwin work
+                       sed -i \
+                               -e 
"s/ac_cv_prog_ac_ct_AR='libtool/ac_cv_prog_AR='${CHOST}-libtool/" \
+                               configure.ac || die
+               fi
+       fi
+
+       eapply_user
+
+       eautoreconf
+}
+
+src_configure() {
+       local modules="win32,win32ole" myconf=
+
+       # -fomit-frame-pointer makes ruby segfault, see bug #150413.
+       filter-flags -fomit-frame-pointer
+       # In many places aliasing rules are broken; play it safe
+       # as it's risky with newer compilers to leave it as it is.
+       append-flags -fno-strict-aliasing
+
+       # Socks support via dante
+       if use socks5 ; then
+               # Socks support can't be disabled as long as SOCKS_SERVER is
+               # set and socks library is present, so need to unset
+               # SOCKS_SERVER in that case.
+               unset SOCKS_SERVER
+       fi
+
+       # Increase GC_MALLOC_LIMIT if set (default is 8000000)
+       if [ -n "${RUBY_GC_MALLOC_LIMIT}" ] ; then
+               append-flags "-DGC_MALLOC_LIMIT=${RUBY_GC_MALLOC_LIMIT}"
+       fi
+
+       # ipv6 hack, bug 168939. Needs --enable-ipv6.
+       use ipv6 || myconf="${myconf} --with-lookup-order-hack=INET"
+
+       # Determine which modules *not* to build depending in the USE flags.
+       if ! use berkdb ; then
+               modules="${modules},dbm"
+       fi
+       if ! use gdbm ; then
+               modules="${modules},gdbm"
+       fi
+       if ! use ssl ; then
+               modules="${modules},openssl"
+       fi
+       if ! use tk ; then
+               modules="${modules},tk"
+       fi
+
+       # Provide an empty LIBPATHENV because we disable rpath but we do not
+       # need LD_LIBRARY_PATH by default since that breaks USE=multitarget
+       # #564272
+       INSTALL="${EPREFIX}/usr/bin/install -c" LIBPATHENV="" econf \
+               --program-suffix=${MY_SUFFIX} \
+               --with-soname=ruby${MY_SUFFIX} \
+               --with-readline-dir="${EPREFIX}"/usr \
+               --enable-shared \
+               --enable-pthread \
+               --disable-rpath \
+               --without-baseruby \
+               --with-out-ext="${modules}" \
+               $(use_with jemalloc jemalloc) \
+               $(use_enable jit jit-support) \
+               $(use_enable jit yjit) \
+               $(use_enable socks5 socks) \
+               $(use_enable systemtap dtrace) \
+               $(use_enable doc install-doc) \
+               --enable-ipv6 \
+               $(use_enable static-libs static) \
+               $(use_enable static-libs install-static-library) \
+               $(use_with static-libs static-linked-ext) \
+               $(use_enable debug) \
+               ${myconf} \
+               --enable-option-checking=no
+
+       # Makefile is broken because it lacks -ldl
+       rm -rf ext/-test-/popen_deadlock || die
+}
+
+src_compile() {
+       export 
LD_LIBRARY_PATH="${S}:${ED}/usr/$(get_libdir)${LD_LIBRARY_PATH+:}${LD_LIBRARY_PATH}"
+       emake V=1 EXTLDFLAGS="${LDFLAGS}" MJIT_CFLAGS="${CFLAGS}" 
MJIT_OPTFLAGS="" MJIT_DEBUGFLAGS=""
+}
+
+src_test() {
+       export 
LD_LIBRARY_PATH="${S}:${ED}/usr/$(get_libdir)${LD_LIBRARY_PATH+:}${LD_LIBRARY_PATH}"
+       emake V=1 check
+}
+
+src_install() {
+       # Remove the remaining bundled gems. We do this late in the process
+       # since they are used during the build to e.g. create the
+       # documentation.
+       einfo "Removing default gems before installation"
+       rm -rf lib/bundler* lib/rdoc/rdoc.gemspec || die
+
+       # Ruby is involved in the install process, we don't want interference 
here.
+       unset RUBYOPT
+
+       local MINIRUBY=$(echo -e 'include Makefile\ngetminiruby:\n\t@echo 
$(MINIRUBY)'|make -f - getminiruby)
+
+       
LD_LIBRARY_PATH="${S}:${ED}/usr/$(get_libdir)${LD_LIBRARY_PATH+:}${LD_LIBRARY_PATH}"
+
+       if [[ ${CHOST} == *darwin* ]] ; then
+               
DYLD_LIBRARY_PATH="${S}:${ED}/usr/$(get_libdir)${DYLD_LIBRARY_PATH+:}${DYLD_LIBRARY_PATH}"
+               export DYLD_LIBRARY_PATH
+       fi
+
+       RUBYLIB="${S}:${ED}/usr/$(get_libdir)/ruby/${RUBYVERSION}"
+       for d in $(find "${S}/ext" -type d) ; do
+               RUBYLIB="${RUBYLIB}:$d"
+       done
+       export LD_LIBRARY_PATH RUBYLIB
+
+       # Create directory for the default gems
+       local gem_home="${EPREFIX}/usr/$(get_libdir)/ruby/gems/${RUBYVERSION}"
+       mkdir -p "${D}/${gem_home}" || die "mkdir gem home failed"
+
+       emake V=1 DESTDIR="${D}" GEM_DESTDIR=${gem_home} install
+
+       # Remove installed rubygems and rdoc copy
+       rm -rf "${ED}/usr/$(get_libdir)/ruby/${RUBYVERSION}/rubygems" || die 
"rm rubygems failed"
+       rm -rf "${ED}/usr/bin/"gem"${MY_SUFFIX}" || die "rm rdoc bins failed"
+       rm -rf "${ED}/usr/$(get_libdir)/ruby/${RUBYVERSION}"/rdoc* || die "rm 
rdoc failed"
+       rm -rf "${ED}/usr/bin/"{bundle,bundler,ri,rdoc}"${MY_SUFFIX}" || die 
"rm rdoc bins failed"
+
+       if use doc; then
+               emake DESTDIR="${D}" GEM_DESTDIR=${gem_home} install-doc
+       fi
+
+       if use examples; then
+               dodoc -r sample
+       fi
+
+       dodoc ChangeLog NEWS.md README*
+       dodoc -r doc
+}
+
+pkg_postinst() {
+       if [[ ! -n $(readlink "${EROOT}"/usr/bin/ruby) ]] ; then
+               eselect ruby set ruby${MY_SUFFIX}
+       fi
+
+       elog
+       elog "To switch between available Ruby profiles, execute as root:"
+       elog "\teselect ruby set ruby(23|24|...)"
+       elog
+}
+
+pkg_postrm() {
+       eselect ruby cleanup
+}


Reply via email to